Bug 529198 - Review Request: pynac - manipulation of symbolic expressions
Review Request: pynac - manipulation of symbolic expressions
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: David A. Wheeler
Fedora Extras Quality Assurance
:
: 491545 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-15 09:13 EDT by Thomas Spura
Modified: 2010-02-01 20:12 EST (History)
5 users (show)

See Also:
Fixed In Version: 0.1.11-1.fc12
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-02-01 20:12:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
dwheeler: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Thomas Spura 2009-10-15 09:13:03 EDT
Spec URL: http://tomspur.fedorapeople.org/review/pynac.spec
SRPM URL: http://tomspur.fedorapeople.org/review/pynac-0.1.9-1.fc11.src.rpm
Description:
Pynac is a derivative of the C++ library GiNaC, which allows manipulation of
symbolic expressions. It currently provides the backend for symbolic
expressions in Sage.

The main difference between Pynac and GiNaC is that Pynac relies on Sage to
provide the operations on numerical types, while GiNaC depends on CLN for this
purpose.

__________________________

$ rpmlint pynac.spec ../SRPMS/pynac-0.1.9-1.fc11.src.rpm ../RPMS/x86_64/pynac-*.rpm
pynac-devel.x86_64: W: no-documentation
pynac-static.x86_64: W: no-documentation
5 packages and 1 specfiles checked; 0 errors, 2 warnings.

Builds in koji:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1747273
__________________________

This is part of packaging sage into fedora [1].


[1] https://fedoraproject.org/wiki/SIGs/SciTech/SAGE#Missing_required_components
Comment 1 Thomas Spura 2009-10-15 09:13:18 EDT
*** Bug 491545 has been marked as a duplicate of this bug. ***
Comment 2 Susi Lehtola 2009-10-16 08:00:50 EDT
Do you *really* want to provide a static library...? Is there a working --disable-static option in configure?
Comment 3 Thomas Spura 2009-10-16 08:56:29 EDT
Yes --disable-static works.

$ rpmlint pynac.spec ../SRPMS/pynac-0.1.9-2.fc11.src.rpm ../RPMS/x86_64/pynac-0.1.9-2.fc11.x86_64.rpm ../RPMS/x86_64/pynac-debuginfo-0.1.9-2.fc11.x86_64.rpm ../RPMS/x86_64/pynac-devel-0.1.9-2.fc11.x86_64.rpm 
pynac-devel.x86_64: W: no-documentation
4 packages and 1 specfiles checked; 0 errors, 1 warnings.


%changelog
* Fri Oct 16 2009 Thomas Spura <tomspur@fedoraproject.org> - 0.1.9-2
- disable static librariy

Spec URL: http://tomspur.fedorapeople.org/review/pynac.spec
SRPM URL: http://tomspur.fedorapeople.org/review/pynac-0.1.9-2.fc11.src.rpm
Comment 4 Thomas Spura 2010-01-15 15:49:12 EST
$ rpmlint pynac-0.1.10-1.fc12.src.rpm x86_64/pynac-*
pynac-devel.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 1 warnings.

%changelog
- update to new version
- use %%global and not %%define


Spec URL: http://tomspur.fedorapeople.org/review/pynac.spec
SRPM URL: http://tomspur.fedorapeople.org/review/pynac-0.1.10-1.fc12.src.rpm
Comment 5 David A. Wheeler 2010-01-26 22:30:17 EST
Here's my formal review, using http://fedoraproject.org/wiki/Packaging:ReviewGuidelines - there are a few issues, easily fixed.

    *  MUST: rpmlint must be run on every package. The output should be posted in the review.[1]

$ rpmlint SPECS/pynac.spec RPMS/x86_64/pynac-* SRPMS/pynac-0.1.10-1.fc12.src.rpm 
pynac-devel.x86_64: W: no-documentation
4 packages and 1 specfiles checked; 0 errors, 1 warnings.

This is as noted above.  It's a warning, not an error; documentation would be really nice,  but isn't strictly required.

    * MUST: The package must be named according to the Package Naming Guidelines.

OK.

    * MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .

OK

    * MUST: The package must meet the Packaging Guidelines .

OK.

    * MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

OK.  GPLv2+.

    * MUST: The License field in the package spec file must match the actual license. [3]

OK.  I did a spot-check of source code; in directory src/ginac
the files add.cpp and function.pl are clearly GPLv2+.

    * MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

OK.  COPYING has GPLv2.

    * MUST: The spec file must be written in American English. [5]
OK

    * MUST: The spec file for the package MUST be legible. [6]
OK

    * MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

OK.
$ wget http://www.sagemath.org/packages/standard/pynac-0.1.10.spkg
$ sha256sum pynac-0.1.10.spkg ~/rpmbuild/SOURCES/pynac-0.1.10.spkg 
547326b9af0130ed8891847deca58787b651f346cbf609b3b067176276a81b1b  pynac-0.1.10.spkg
547326b9af0130ed8891847deca58787b651f346cbf609b3b067176276a81b1b  /home/rpmbuilder/rpmbuild/SOURCES/pynac-0.1.10.spkg

    * MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

OK.  Works on x86_64 Fedora 12.

    * MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

OK.  It builds on all architectures, as shown by this koji build:
 koji build --scratch dist-f12 ./pynac-0.1.10-1.fc12.src.rpm 

$ koji build --scratch dist-f12 ./pynac-0.1.10-1.fc12.src.rpm 
Uploading srpm: ./pynac-0.1.10-1.fc12.src.rpm
[====================================] 100% 00:00:16   2.10 MiB 128.73 KiB/sec
Created task: 1947029
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=1947029
Watching tasks (this may be safely interrupted)...
1947029 build (dist-f12, pynac-0.1.10-1.fc12.src.rpm): free
1947029 build (dist-f12, pynac-0.1.10-1.fc12.src.rpm): free -> open (ppc05.phx2.fedoraproject.org)
  1947030 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc): free
  1947033 buildArch (pynac-0.1.10-1.fc12.src.rpm, i686): free
  1947032 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc64): free
  1947031 buildArch (pynac-0.1.10-1.fc12.src.rpm, x86_64): free
  1947030 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc): free -> open (ppc03.phx2.fedoraproject.org)
  1947032 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc64): free -> open (ppc09.phx2.fedoraproject.org)
  1947033 buildArch (pynac-0.1.10-1.fc12.src.rpm, i686): free -> open (x86-03.phx2.fedoraproject.org)
  1947031 buildArch (pynac-0.1.10-1.fc12.src.rpm, x86_64): free -> open (x86-06.phx2.fedoraproject.org)
  1947033 buildArch (pynac-0.1.10-1.fc12.src.rpm, i686): open (x86-03.phx2.fedoraproject.org) -> closed
  0 free  4 open  1 done  0 failed
  1947031 buildArch (pynac-0.1.10-1.fc12.src.rpm, x86_64): open (x86-06.phx2.fedoraproject.org) -> closed
  0 free  3 open  2 done  0 failed
  1947032 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc64): open (ppc09.phx2.fedoraproject.org) -> closed
  0 free  2 open  3 done  0 failed
  1947030 buildArch (pynac-0.1.10-1.fc12.src.rpm, ppc): open (ppc03.phx2.fedoraproject.org) -> closed
  0 free  1 open  4 done  0 failed
1947029 build (dist-f12, pynac-0.1.10-1.fc12.src.rpm): open (ppc05.phx2.fedoraproject.org) -> closed
  0 free  0 open  5 done  0 failed


    * MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

OK.  Did a mock build, it built.

Also, see the koji builds.

    * MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]

NA.  No locales.

    * MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]

OK.

    * MUST: Packages must NOT bundle copies of system libraries.[11]
OK

    * MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]

NA

    * MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]

OK

    * MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [14]

OK

    * MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]

OK

    * MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [16]
OK

    * MUST: Each package must consistently use macros. [17]

ISSUE.
It uses $RPM_BUILD_ROOT and %{optflags}.

As required by:
 http://fedoraproject.org/wiki/Packaging/Guidelines#macros
it should use one style or the other.


    * MUST: The package must contain code, or permissable content. [18]

OK

    * MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [19]

NA

    * MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [19]

OK

    * MUST: Header files must be in a -devel package. [20]
OK

    * MUST: Static libraries must be in a -static package. [21]
NA

    * MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [22]

ISSUE.  It has a .pc file, but no "Requires: pkgconfig".

    * MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [20]

OK

    * MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [23]

OK

    * MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[21]

OK

    * MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [24]

NA

    * MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [25]

OK

    * MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [26]

OK

    * MUST: All filenames in rpm packages must be valid UTF-8. [27]
OK


SHOULD Items:

    * SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [28]

NA

    * SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [29]

None included.

    * SHOULD: The reviewer should test that the package builds in mock. [30]

I did; it builds.

    * SHOULD: The package should compile and build into binary rpms on all supported architectures. [31]

I did; see the koji output above.

    * SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

I didn't do this.  It's a library, so I can't just a command line, and the docs are lousy.  The primary user is SAGE, so I'll let the SAGE packagers check that.

    * SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [32]

OK

    * SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [23]

NA

    * SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [22]

OK

    * SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [33]

OK

    * SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[34]

NA - it's a library.
Comment 6 David A. Wheeler 2010-01-26 22:31:58 EST
In short, the only issues I found were:

* MUST: Each package must consistently use macros. [17]

ISSUE.
It uses $RPM_BUILD_ROOT and %{optflags}.

* MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'
(for directory ownership and usability). [22]

ISSUE.  It has a .pc file, but no "Requires: pkgconfig".
Comment 7 Christoph Wickert 2010-01-27 08:26:12 EST
Just for completeness and because David asked to become a sponsor recently:

(In reply to comment #6)
> ISSUE.  It has a .pc file, but no "Requires: pkgconfig".    

Strictly speaking this is not needed any longer because rpm nowadays detects this automatically:

Processing files: pynac-devel-0.1.10-1.fc12.x86_64
Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Requires: /usr/bin/pkg-config libpynac-0.1.so.10()(64bit)

However I agree with David that the devel package should require pkgconfig explicitly.


Please add INSTALL='install -p' to 'make install...' to preserve the original time stamps of the header files in the devel package. See 
https://fedoraproject.org/wiki/Packaging/Guidelines#Timestamps
Comment 8 Thomas Spura 2010-01-27 17:17:50 EST
Thanks for the review.

(In reply to comment #6)
> In short, the only issues I found were:
> 
> * MUST: Each package must consistently use macros. [17]
> 
> ISSUE.
> It uses $RPM_BUILD_ROOT and %{optflags}.

Now it is %{buildroot} and %{optflags}.

(In reply to comment #7)
> Just for completeness and because David asked to become a sponsor recently:
> 
> (In reply to comment #6)
> > ISSUE.  It has a .pc file, but no "Requires: pkgconfig".    
> 
> Strictly speaking this is not needed any longer because rpm nowadays detects
> this automatically:

Not needed = no blocker at all ;)

But requiring it now, till the guidelines hopefully change.

> Please add INSTALL='install -p' to 'make install...'

Done.

(Also updated to a new version.)


Spec URL: http://tomspur.fedorapeople.org/review/pynac.spec
SRPM URL: http://tomspur.fedorapeople.org/review/pynac-0.1.11-1.fc12.src.rpm
Comment 9 David A. Wheeler 2010-01-28 18:32:08 EST
My theory is, if it's a MUST in the guidelines, then it's required... even if it's automated.

I checked; all of the comments above have now been addressed.  Thanks!!

I did a few checks to make sure the new version didn't add surprises.

I rebuilt the new version.  It whines with a lot of warnings, but it builds fine.

rpmlint output for this version is the same as before (see comment 5), so that's fine:
rpmlint pynac.spec ../RPMS/x86_64/pynac-* ../SRPMS/pynac-0.1.11-1.fc12.src.rpm 
pynac-devel.x86_64: W: no-documentation
4 packages and 1 specfiles checked; 0 errors, 1 warnings.

I also did a mock build to see if new dependencies were created:
  mock --rebuild ../SRPMS/pynac-0.1.11-1.fc12.src.rpm 
and it went fine.

APPROVED.
Comment 10 Thomas Spura 2010-01-29 06:15:39 EST
Thanks for the review.

New Package CVS Request
=======================
Package Name: pynac
Short Description: manipulation of symbolic expressions
Owners: tomspur
Branches: F-12
InitialCC:
Comment 11 Christoph Wickert 2010-01-29 06:16:18 EST
(In reply to comment #8)
> Not needed = no blocker at all ;)
> 
> But requiring it now, till the guidelines hopefully change.

It will only work with rpm >= 4.7.0, so the guidelines are unlikely to change any time soon. This is why it's still a MUST and therefor a blocker.

Rule of thumb: Whatever is requiered for directory ownership should be listed in the spec explicitly.
Comment 12 Mamoru TASAKA 2010-01-29 06:31:56 EST
About Requires: pkgconfig
- Note that the rule "any packages containing pkgconfig .pc file
  must have Requires: pkgconfig" is already removed on Fedora, see:
  https://fedoraproject.org/wiki/Packaging/Guidelines#Pkgconfig_Files
  https://fedoraproject.org/wiki/EPEL/GuidelinesAndPolicies#Distribution_specific_guidelines

  Well, actually I found that review guideline wiki page still
  leaves this as must item, however this is just not updated.
Comment 13 Kevin Fenzi 2010-01-31 13:15:29 EST
CVS done (by process-cvs-requests.py).
Comment 14 Thomas Spura 2010-01-31 15:30:25 EST
(In reply to comment #12)
> About Requires: pkgconfig
> - Note that the rule "any packages containing pkgconfig .pc file
>   must have Requires: pkgconfig" is already removed on Fedora, see:
>   https://fedoraproject.org/wiki/Packaging/Guidelines#Pkgconfig_Files

FYI:

The new guidelines doesn't say something, that pkgconfig is *not* allowed to be required.

So I explicitely require it for now, because this version was approved above and will remove it again with the next update to a new version some time in the future.
Comment 15 Fedora Update System 2010-01-31 15:32:15 EST
pynac-0.1.11-1.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/pynac-0.1.11-1.fc12
Comment 16 Fedora Update System 2010-02-01 20:12:26 EST
pynac-0.1.11-1.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.